// ---------------------------------------------------------------------------
// 6502/65C02 Turbo Assembler  Version 1.3
// (c)1996 Taboo Productions
//
// 6502/65C02 Turbo Assembler  Version 1.35  ANSI C port
// (c)2000 [BiGFooT/BReeZe^2000]
// ---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include <sys/stat.h>
#include <sys/types.h>

#include <unistd.h>
#include <ctype.h>

#include "bstring.h"
// ---------------------------------------------------------------------------
//#define debug
// ---------------------------------------------------------------------------

struct slabel {
 struct slabel* another;
 long value;
 unsigned type:1;
 unsigned defin:1;
 unsigned forw:1;
 char name[256];
 };

struct smacro {
 struct smacro* another;
 long point;
 long lin;
 char name[336];
 };

#define linelength 4096
static int errors=0,warnings=0;
static int w_on=1;
static int nlin=0;
static long sline;
static char sname[80];
static unsigned low_mem=0xffff,top_mem=0;
static int pass=1;
static unsigned char* mem64=NULL;
static unsigned char* mmap=NULL;
static unsigned address=0,l_address=0;
static struct slabel* labels[27];
static struct smacro* macros=NULL;
static char pline[linelength];
static char llist[linelength];
static int lpoint;
static int ascc=0;
static char ident[256];
static char varname[256];
static char path[80];
static int elseflag=0;
static int pagelo=-1;
static FILE* flist;
static int listing=0;
static int monl=1,soul=1;
static int lastl=0;
static int labfile=0;
static char labname[80];
static int logisave=0;
static unsigned* logitab;

static char s_stack[256];
static struct {long val; char sgn;} e_stack[256];
static long v_stack[256];
static int ssp,esp,vsp;

static char* mnemonic[]={"lda","ldx","ldy","sta","stx","sty","tax","txa",
                  "tay","tya","tsx","txs","pha","php","pla","plp",
                  "clc","cli","cld","clv","sec","sei","sed","bmi",
                  "bpl","beq","bne","bcs","bcc","bvs","bvc","jmp",
                  "jsr","rts","rti","cmp","cpx","cpy","bit","inc",
                  "inx","iny","dec","dex","dey","adc","sbc","and",
                  "ora","eor","asl","lsr","rol","ror","nop","brk",
                  "stz","phx","phy","plx","ply","bra","trb","tsb"};

static int cmnems[]={12417,12440,12441,20097,20120,20121,20536,21249,20537,21281,
              21112,21267,16641,16656,16769,16784,3459,3465,3460,3478,19619,
              19625,19620,2473,2572,2225,2501,2163,2147,2771,2755,10672,
              10866,19091,19081,3504,3608,3609,2356,9667,9688,9689,4259,4280,
              4281,1155,19523,1476,15937,5618,1644,12914,18924,18930,14832,
              2635,20122,16664,16665,16792,16793,2625,21058,21090};

static unsigned char c6502[][13]=
//        #b   w    b   w,x  b,x  w,y  b,y (b,x) (b),y (w) (b) (w,x)
   {0xff,0xa9,0xad,0xa5,0xbd,0xb5,0xb9,0xff,0xa1,0xb1,0xff,0xff,0xff, // lda
    0xff,0xa2,0xae,0xa6,0xff,0xff,0xbe,0xb6,0xff,0xff,0xff,0xff,0xff, // ldx
    0xff,0xa0,0xac,0xa4,0xbc,0xb4,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // ldy
    0xff,0xff,0x8d,0x85,0x9d,0x95,0x99,0xff,0xb1,0x91,0xff,0xff,0xff, // sta
    0xff,0xff,0x8e,0x86,0xff,0xff,0xff,0x96,0xff,0xff,0xff,0xff,0xff, // stx
    0xff,0xff,0x8c,0x84,0xff,0x94,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // sty
    0xaa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // tax
    0x8a,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // txa
    0xa8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // tay
    0x98,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // tya
    0xba,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // tsx
    0x9a,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // txs
    0x48,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // pha
    0x08,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // php
    0x68,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // pla
    0x28,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // plp
    0x18,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // clc
    0x58,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // cli
    0xd8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // cld
    0xb8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // clv
    0x38,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // sec
    0x78,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // sei
    0xf8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // sed
    0xff,0xff,0x30,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bmi
    0xff,0xff,0x10,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bpl
    0xff,0xff,0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // beq
    0xff,0xff,0xd0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bne
    0xff,0xff,0xb0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bcs
    0xff,0xff,0x90,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bcc
    0xff,0xff,0x70,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bvs
    0xff,0xff,0x50,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bvc
    0xff,0xff,0x4c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x6c,0xff,0xff, // jmp
    0xff,0xff,0x20,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // jsr
    0x60,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // rts
    0x40,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // rti
    0xff,0xc9,0xcd,0xc5,0xdd,0xd5,0xd9,0xff,0xc1,0xd1,0xff,0xff,0xff, // cmp
    0xff,0xe0,0xec,0xe4,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // cpx
    0xff,0xc0,0xcc,0xc4,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // cpy
    0xff,0xff,0x2c,0x24,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bit
    0xff,0xff,0xee,0xe6,0xfe,0xf6,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // inc
    0xe8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // inx
    0xc8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // iny
    0xff,0xff,0xce,0xc6,0xde,0xd6,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // dec
    0xca,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // dex
    0x88,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // dey
    0xff,0x69,0x6d,0x65,0x7d,0x75,0x79,0xff,0x61,0x71,0xff,0xff,0xff, // adc
    0xff,0xe9,0xed,0xe5,0xfd,0xf5,0xf9,0xff,0xe1,0xf1,0xff,0xff,0xff, // sbc
    0xff,0x29,0x2d,0x25,0x3d,0x35,0x39,0xff,0x21,0x31,0xff,0xff,0xff, // and
    0xff,0x09,0x0d,0x05,0x1d,0x15,0x19,0xff,0x01,0x11,0xff,0xff,0xff, // ora
    0xff,0x49,0x4d,0x45,0x5d,0x55,0x59,0xff,0x41,0x51,0xff,0xff,0xff, // eor
    0x0a,0xff,0x0e,0x06,0x1e,0x16,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // asl
    0x4a,0xff,0x4e,0x46,0x5e,0x56,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // lsr
    0x2a,0xff,0x2e,0x26,0x3e,0x36,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // rol
    0x6a,0xff,0x6e,0x66,0x7e,0x76,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // ror
    0xea,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // nop
    0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // brk
    0xff,0xff,0x9c,0x64,0x9e,0x74,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // stz
    0xda,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // phx
    0x5a,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // phy
    0xfa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // plx
    0x7a,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // ply
    0xff,0xff,0x80,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // bra
    0xff,0xff,0x1c,0x14,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // trb
    0xff,0xff,0x0c,0x04,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};// tsb

static char cmnem[]={0,3,31,35,38,38,38,39,42,45,46,47,48,49};
static char copr[]={11,11,12,11,1,5,4,0,0,11,11,11,11,11};
static unsigned char ccode[]={0xb2,0x92,0x7c,0xd2,0x89,0x34,0x3c,0x1a,0x3a,
                       0x72,0xf2,0x32,0x12,0x52};
#define CNUM 14

static char leno[]={1,2,3,2,3,2,3,2,2,2,3,2,3};

static int last_mnem=55;
static char* command[]={"byte","text","word","offs","macro","endm","for",
                 "next","if","else","fi","rept","include","binary",
                 "comment","endc","page","endp","logical","here"};
#define COMMANDS 20

// ------------- CODE STARTS HERE --------------------------------------------

void help() {
 printf("\nSyntax:  64tass [options] source [object] [listfile]\n");
 printf("/?, /h   Display this help screen\n");
 printf("/w       Ignore warning messages\n");
 printf("/n       Generate nonlinear output file\n");
 printf("/c       Allow 65C02 mnemonics\n");
 printf("/a       Convert ASCII to PETASCII\n");
 printf("/m       Don't put monitor code into listing\n");
 printf("/s       Don't put source code into listing\n");
 printf("/l<name> Generate a file with all labels\n");
 exit(0);
 }

// ---------------------------------------------------------------------------

void mfree() {					// flush memory
 int i;
 
 struct slabel *tmp,*tmp2;
 struct smacro *tmp4,*tmp3;
 
 if (mem64) free(mem64);			// free 64k codemem
 if (mmap) free(mmap);				// free memorymap
 for(i=0; i<27; i++) {				// free labels
  tmp=labels[i];
  while (tmp) {
   tmp2=tmp->another;
   free(tmp);
   tmp=tmp2;
   }
  }

 tmp3=macros;					// free macros
 while (tmp3) {
  tmp4=tmp3->another;
  free(tmp3);
  tmp3=tmp4;
  }
 }

// ---------------------------------------------------------------------------

void status() {
 printf("Error messages:    ");
 if (errors) printf("%i\n",errors);
 else printf("None\n");
 printf("Warning messages:  ");
 if (warnings) printf("%i\n",warnings);
 else printf("None\n");
 printf("Passes:            %i\n",pass);
 printf("Range:             ");
 if (low_mem<=top_mem) printf("$%04x-$%04x\n",low_mem,top_mem);
 else printf("None\n");

 mfree();
 }

// ---------------------------------------------------------------------------

void err_msg(int no,char* prm) {
 char error[12]="[**Error**]";
 char fatal[12]="[**Fatal**]";
 char warning[12]="[*Warning*]";
 
 sline++;
 switch(no) {
  case 1: printf("%s %s(%ld) Double defined %s\n",error,sname,sline,prm); errors++; break;
  case 2: printf("%s %s(%ld) Not defined %s\n",error,sname,sline,prm); errors++; break;
  case 3: printf("%s %s(%ld) Extra characters on line\n",error,sname,sline); errors++; break;
  case 4: printf("%s %s(%ld) Constant too large\n",error,sname,sline); errors++; break;
  case 5: printf("%s %s(%ld) General syntax\n",error,sname,sline); errors++; break;
  case 6: printf("%s %s(%ld) %s expected\n",error,sname,sline,prm); errors++; break;
  case 7: printf("%s %s(%ld) Expression syntax\n",error,sname,sline); errors++; break;
  case 8: if ((w_on) && (pass==2)) {printf("%s %s(%ld) Using variable %s before declaration\n",warning,sname,sline,prm); warnings++;} break;
  case 9: printf("%s %s(%ld) Branch too far\n",error,sname,sline); errors++; break;
  case 10: printf("%s %s(%ld) Missing argument\n",error,sname,sline); errors++; break;
  case 11: if ((w_on) && (pass==2)) {printf("%s %s(%ld) Top of memory excedeed\n",warning,sname,sline); warnings++;} break;
  case 12: printf("%s Can't locate file: %s\n",fatal,sname); errors++; status(); exit(1);
  case 13: printf("%s Out of memory\n",fatal); errors++; status(); exit(1);
  case 14: printf("%s Can't write object file: %s\n",fatal,prm); status(); exit(1);
  case 15: printf("%s %s(%ld) Line too long\n",fatal,sname,sline); errors++; status(); exit(1);
  case 16: printf("%s %s(%ld) Reserved word used as symbol\n",error,sname,sline); errors++; break;
  case 17: printf("%s %s(%ld) Illegal operand\n",error,sname,sline); errors++; break;
  case 18: if ((w_on) && (pass==2)) {printf("%s %s(%ld) Possibly incorrectly used A\n",warning,sname,sline); warnings++;} break;
  case 19: printf("%s Can't write listing file: %s\n",fatal,prm); status(); exit(1);
  case 20: printf("%s %s(%ld) Page error at $%04x\n",error,sname,sline,l_address); errors++; break;
  case 21: printf("%s Can't write label file: %s\n",fatal,prm); status(); exit(1);
  }
 sline--;
 if (errors==100) {printf("%s %s(%ld) Too many errors\n",fatal,sname,sline); status(); exit(1);}
 }

// ---------------------------------------------------------------------------

struct slabel* find_label(char* name) {
 struct slabel* temp;
  
 temp=labels[name[0]=='_' ? 26 : name[0]-'a'];
 while (temp!=NULL) {
  if (!strcmp(temp->name,name+1)) break;
  temp=temp->another;
  }
 return temp;
 }

// ---------------------------------------------------------------------------

struct slabel* new_label(char* name) {
 struct slabel* temp;

 temp=(struct slabel*)malloc(strlen(name)+9);
 if (temp==NULL) err_msg(13,"");
 strcpy(temp->name,name+1);
 temp->another=labels[name[0]=='_' ? 26 : name[0]-'a'];
 labels[name[0]=='_' ? 26 : name[0]-'a']=temp;
 return temp;
 }

// ---------------------------------------------------------------------------

struct smacro* find_macro(char* name) {
 struct smacro* temp;
 temp=macros;
 while (temp!=NULL) {
  if (!strcmp(temp->name,name)) break;
  temp=temp->another;
  }
 return temp;
 }

// ---------------------------------------------------------------------------

struct smacro* new_macro(char* name) {
 int i,j;
 struct smacro* temp;
  
 temp=(struct smacro*)malloc(strlen(name)+strlen(sname)+14);
 if (temp==NULL) err_msg(13,"");
 for(i=0; (temp->name[i]=name[i])!=0; i++);
 for(j=0; (temp->name[++i]=sname[j])!=0; j++);
 temp->another=macros;
 macros=temp;
 return macros;
 }

// ---------------------------------------------------------------------------

void readln(FILE* fle) {
 int i=0,q=0;
 char ch;
  
 pline[0]=0;
 fgets(pline,sizeof(pline),fle);
 if (!pline[0]) strcpy(pline,"\n");
 sline++;
 strcpy(llist,pline);
 if ((pline[strlen(pline)-1]!=13) && (pline[strlen(pline)-1]!=10) && (!feof(fle))) err_msg(15,"");
 while (((ch=pline[i])!=0) && (ch!=13) && (ch!=10)) {
  if (ch==9) pline[i]=' ';
  else if (ch=='"') q=!q;
  else if ((!q) && (ch==';')) break;
  i++;
  }
 while (pline[i-1]==' ') i--;
 pline[i]=0;
 lpoint=0;
 }

// ---------------------------------------------------------------------------

void pokeb(unsigned *addr,unsigned char byte) {
 int valami;
 valami=*addr;

 if (nlin) mmap[valami>>3] |= (1<<(valami & 7));
 if (valami<low_mem) low_mem=valami;
 if (valami>top_mem) top_mem=valami;
 if (valami<65536u) mem64[valami]=byte;

 valami++;
 l_address++;
 if (valami>=65536u) err_msg(11,"");
 *addr=valami;
 }

// ---------------------------------------------------------------------------

void pokew(unsigned *addr,unsigned word) {
 pokeb(addr,word&255);
 pokeb(addr,word/256);
 }

// ---------------------------------------------------------------------------

char tolower_tab[] = {
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,
0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,
0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,
0x40,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x5b,0x5c,0x5d,0x5e,0x5f,
0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,
0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,
0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,
0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,
0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,
0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,
0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,
0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,
0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff};

//#define lowcase(ch) ((((char)ch)>='A' && ((char)ch)<='Z') ? ((char)ch)-('A'-'a') : ((char)ch))

#define lowcase(ch) tolower_tab[ch]
#define ignore() while(pline[lpoint]==' ') lpoint++

// ---------------------------------------------------------------------------

char iget() {
 ignore();
 return lowcase(pline[lpoint++]);
 }

// ---------------------------------------------------------------------------

char petascii(char ch) {
 if (!ascc) return ch;
 if ((ch>='a') && (ch<='z')) return ch-0x20;
 if ((ch>='A') && (ch<='Z')) return ch+0x80;
 return ch;
 }

// ---------------------------------------------------------------------------

int what(int *tempno) {
 char ch;
 int  no;  
  
 unsigned mnm=0;
 int lt;

 no=*tempno;

 switch (iget()) {
  case 0: return 9;
  case '*': return 10;
  case '=': return 8;
  case '#': return 3;
  case ':': return 12;
  case '.': for (no=0; no<COMMANDS; no++) {
             for (ch=0; ch<strlen(command[no]); ch++)
              if (command[no][ch]!=lowcase(pline[lpoint+ch])) break;
             if (ch==strlen(command[no])) break;
             }
            if (no<COMMANDS)
             if (((ch=lowcase(pline[lpoint+strlen(command[no])]))<'a' ||
                   ch>'z')&& ch!='_') {
              lpoint+=strlen(command[no]);
              *tempno=no;
              return 7;
              }
            *tempno=no; 
            return 0;
             
  case ',': if ((ch=iget())=='y') { *tempno=no; return 5; }
             if (ch=='x') {
              if (iget()==')') { *tempno=no; return 6; }
              else {lpoint--; *tempno=no; return 4;}
              }
             else {lpoint--; *tempno=no; return 11;}
             
  default: //ignore();

//             for (no=0; no<last_mnem+1; no++) {
//              for (ch=0; ch<3; ch++)
//                 if (mnemonic[no][ch]!=lowcase(pline[lpoint-1+ch])) break;
//               if (ch==3) break;
//             }

           if ((isalpha(pline[lpoint-1])) && (isalpha(pline[lpoint])) && (isalpha(pline[lpoint+1]))) {
            for(lt=0; lt<3; lt++) {
             mnm=(mnm<<5)+(lowcase(pline[lpoint-1+lt]) & 31);
             }
            for(no=0; no<last_mnem+1; no++)
             if(mnm==cmnems[no]) break;
            if (no<last_mnem+1) {
             if (((ch=lowcase(pline[lpoint+2]))<'a' || ch>'z')&& ch!='_') {
              lpoint+=2;
              *tempno=no;
              return 2;
              }
             }
            }
           lpoint--;
           no=(((ch=lowcase(pline[lpoint]))>='a' && ch<='z') || ch=='_');
           if (no || (ch>='0' && ch<='9') || ch=='$' || ch=='%' ||
             ch=='"' || ch=='<' || ch=='>' || ch=='-'|| ch=='+' ||
             ch=='(' || ch=='!' || ch=='@') { *tempno=no; return 1; }
           *tempno=no;
           return 0;
           }
 }

int get_ident() {
 int v,code;
 int i=0;
 char ch;
 
 if ((v=what(&code))!=1 || !code) {
  if (v==2) err_msg(16,"");
  else err_msg(7,"");
  return 1;
  }
 while (((ch=lowcase(pline[lpoint]))>='a' && ch<='z') || (ch>='0' && ch<='9') || ch=='_') { ident[i++]=ch; lpoint++; }
// lpoint--;
 ident[i]=0;
 return 0;
 }

long get_num(int *cd, int md) {
 long val=0;
 struct slabel* tmp;

 unsigned char ch=iget();
 *cd=0;

 switch (ch) {
    case '$': ignore();
              while ((ch=lowcase(pline[lpoint++]))>='0' && ch<='9' ||
                    ch>='a' && ch<='f') {
                if (val>0x7ffffffl) {err_msg(4,""); return 0;}
                val=(val<<4)+(ch=ch<='9' ? ch-'0' : ch-'a'+10);
              }
              lpoint--;
              *cd=1;
              return val;
    case '%': ignore();
              while ((ch=pline[lpoint++])=='0' || ch=='1') {
                if (val>0x3fffffffl) {err_msg(4,""); return 0;}
                val=(val<<1)+ch-'0';
              }
              lpoint--;
              *cd=1;
              return val;
    case '"': if ((ch=petascii(pline[lpoint++]))!=0) {
                if (pline[lpoint++]=='"') {*cd=1; return ch;}
              lpoint--;
              err_msg(7,"");
              return 0;
              }
    case '*': *cd=1; return l_address;
    default: lpoint--;
             if ((ch>='0') && (ch<='9')) {
               while (((ch=pline[lpoint++])>='0') && (ch<='9')) {
                 if (val>(0x7fffffffl-ch+'0')/10) {err_msg(4,""); return 0;}
                 val=(val*10)+ch-'0';
               }
               lpoint--;
               *cd=1;
               return val;
             }
             if (get_ident()) return 0;
             tmp=find_label(ident);
             if (tmp)
               if (pass==2) {
                 if (!(tmp->defin)) {err_msg(2,ident); return 0;}
                 if (tmp->forw) {
                   if (tmp->type) err_msg(8,ident);
                   *cd=2;
                   return tmp->value;
                 }
                 *cd=1;
                 return tmp->value;
               }
               else {
                 if (!(tmp->defin))
                   if (md) {err_msg(2,ident); return 0;}
                   else {*cd=3; return 0;}
                 *cd=1;
                 return tmp->value;
               }
             else {
               if (md) {err_msg(2,ident); return 0;}
               tmp=new_label(ident);
               tmp->defin=0;
               tmp->forw=1;
               *cd=3;
               return 0;
             }
  }
 }

int priority(char ch) {
 if (ch=='(') return 0;
 if (ch=='l' || ch=='h') return 5;
 if (ch=='=' || ch=='<' || ch=='>' || ch=='o' || ch=='g' || ch=='s') return 10;
 if (ch=='+' || ch=='-') return 15;
 if (ch=='*' || ch=='/' || ch=='u') return 20;
 if (ch=='|' || ch=='^') return 25;
 if (ch=='&') return 30;
 if (ch=='m' || ch=='d') return 35;
 if (ch=='n' || ch=='t') return 40;
 return 0;
 }

void pushs(char ch) {
 if ((ch=='n' || ch=='t' || ch=='l' || ch=='h') && ssp &&
   priority(s_stack[ssp-1])==priority(ch)) { s_stack[ssp++]=ch; return; }
 if (!ssp || priority(s_stack[ssp-1])<priority(ch)) {
  s_stack[ssp++]=ch;
  return;
  }
 while (ssp && priority(s_stack[ssp-1])>=priority(ch)) e_stack[esp++].sgn=s_stack[--ssp];
 s_stack[ssp++]=ch;
 }

long get_exp(int *wd, int *df,int *cd,int md) {
 long val;
 int i,cod,nd=0,tp=0;
 char ch;
  
 ssp=esp=0;
 *wd=2;
 *df=1;
 *cd=0;
  
  ignore();
  if ((ch=pline[lpoint])=='@')
    if ((ch=lowcase(pline[++lpoint]))=='b') {*wd=0; lpoint++;}
    else
      if (ch=='w') {*wd=1; lpoint++;}
      else {err_msg(6,"@B or @W"); return 0;}
  ignore();
  if (pline[lpoint]=='(') tp=1;
  while (1) {
    if (!nd) {
      ignore();
      if ((ch=pline[lpoint++])=='(') {s_stack[ssp++]='('; continue;}
      if (ch=='+') continue;
      if (ch=='-') {pushs('n'); continue;}
      if (ch=='!') {pushs('t'); continue;}
      if (ch=='<') {pushs('l'); continue;}
      if (ch=='>') {pushs('h'); continue;}
      lpoint--;
      val=get_num(&cod,md);
      if (!cod) return 0;
      if ((cod==2 || cod==3) && *wd==2) *wd=1;
      if (cod==3) *df=0;
      e_stack[esp].val=val;
      e_stack[esp++].sgn=' ';
      nd=1;
    }
    else {
      ignore();
      if ((ch=pline[lpoint])=='&' || ch=='|' || ch=='^' ||
           ch=='*' || ch=='/' || ch=='+' || ch=='-' || ch=='=' ||
           ch=='<' || ch=='>' || (ch=='!' && pline[lpoint+1]=='=')) {
        if (tp) tp=1;
        if ((ch=='<') && (pline[lpoint+1]=='<')) {pushs('m'); lpoint++;}
        else if ((ch=='>') && (pline[lpoint+1]=='>')) {pushs('d'); lpoint++;}
        else if ((ch=='>') && (pline[lpoint+1]=='=')) {pushs('g'); lpoint++;}
        else if ((ch=='<') && (pline[lpoint+1]=='=')) {pushs('s'); lpoint++;}
        else if ((ch=='/') && (pline[lpoint+1]=='/')) {pushs('u'); lpoint++;}
        else if (ch=='!') {pushs('o'); lpoint++;}
        else pushs(ch);
        nd=0;
        lpoint++;
        continue;
      }
      if (ch==')') {
        while ((ssp) && (s_stack[ssp-1]!='('))
          e_stack[esp++].sgn=s_stack[--ssp];
        lpoint++;
        if ((ssp==1) && (tp)) tp=2;
        if (!ssp) {err_msg(7,""); return 0;}
        ssp--;
        continue;
      }
      while ((ssp) && (s_stack[ssp-1]!='('))
        e_stack[esp++].sgn=s_stack[--ssp];
      if (!ssp) {
        if (tp==2) *cd=3;
        else *cd=1;
        break;
      }
      if (ssp>1) {err_msg(7,""); return 0;}
      if (tp) *cd=2;
      else {err_msg(7,""); return 0;}
      break;
    }
  }
  vsp=0;
  for (i=0; i<esp; i++) {
    if ((ch=e_stack[i].sgn)==' ')
      v_stack[vsp++]=e_stack[i].val;
    else {
      if (ch=='l') {v_stack[vsp-1]&=255; continue;}
      if (ch=='h') {v_stack[vsp-1]/=256; v_stack[vsp-1]&=255; continue;}
      if (ch=='n') {v_stack[vsp-1]=-v_stack[vsp-1]; continue;}
      if (ch=='t') {v_stack[vsp-1]=!v_stack[vsp-1]; continue;}
      if (ch=='=') {v_stack[vsp-2]=v_stack[vsp-2]==v_stack[vsp-1]; vsp--; continue;}
      if (ch=='o') {v_stack[vsp-2]=v_stack[vsp-2]!=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='<') {v_stack[vsp-2]=v_stack[vsp-2]<v_stack[vsp-1]; vsp--; continue;}
      if (ch=='>') {v_stack[vsp-2]=v_stack[vsp-2]>v_stack[vsp-1]; vsp--; continue;}
      if (ch=='g') {v_stack[vsp-2]=v_stack[vsp-2]>=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='s') {v_stack[vsp-2]=v_stack[vsp-2]<=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='*') {v_stack[vsp-2]*=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='/') {v_stack[vsp-2]/=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='u') {v_stack[vsp-2]%=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='+') {v_stack[vsp-2]+=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='-') {v_stack[vsp-2]-=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='&') {v_stack[vsp-2]&=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='|') {v_stack[vsp-2]|=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='^') {v_stack[vsp-2]^=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='m') {v_stack[vsp-2]<<=v_stack[vsp-1]; vsp--; continue;}
      if (ch=='d') {v_stack[vsp-2]>>=v_stack[vsp-1]; vsp--; continue;}
    }
  }
  val=v_stack[0];
  if (!*wd && *df && (val>0xff || val<0)) {err_msg(4,""); *cd=0; return 0;}
  if (*wd==1 && *df && (val>0xffff || val<0)) {err_msg(4,""); *cd=0; return 0;}
  if (*wd==2)
    if ((val<0x100) && (val>=0)) *wd=0;
    else if ((val<0x10000l) && (val>=0)) *wd=1;
  if (*df) return val;
  else return 0;
 }

void wait_cmd(FILE* fil,int no)
{
  int wrap=0;
  int pr,wh;
  
  while (1) {
    if (feof(fil)) {
      char nc[6];
      strcpy(nc,".");
      strcat(nc,command[no]);
      err_msg(6,nc);
      return;
    }
    readln(fil);
    wh=what(&pr);
    if ((wh==7) && (pr==no)) {
      if (!wrap) return;
      else
        if (no!=9) wrap--;
    }
    if (wh==7) {
      if ( ((pr==6) || (pr==11)) && (no==7)) wrap++;
      if ((pr==8) && ((no==9) || (no==10))) wrap++;
      if ((no==9) && (pr==10) && (wrap)) wrap--;
    }
    if (wh==1) {
      get_ident();
      wh=what(&pr);
      if ((wh==7) && (pr==no)) {
        if (!wrap) return;
        else
          if (no!=9) wrap--;
      }
      if (wh==7) {
        if (((pr==6) || (pr==11)) && (no==7)) wrap++;
        if ((pr==8) && ((no==9) || (no==10))) wrap++;
        if ((no==9) && (pr==10) && (wrap)) wrap--;
      }
    }
  }
}

int get_path() {
 int i=0;
 ignore();
 while ((pline[lpoint]) && (pline[lpoint]!=' ') && (i<80))
  path[i++]=pline[lpoint++];
 if (i==80) {err_msg(5,""); return 1;}
 path[i]=0;
 if (what(&i)!=9) {err_msg(3,""); return 1;}
 return 0;
 }

void mtranslate(char* mpr, int nprm)
{
  int q,p,pp,i,j;
  char ch;
  char tmp[linelength];
  
  if (nprm) {
    strcpy(tmp,pline);
    q=0; p=0;
    for (i=0; (ch=tmp[i])!=0; i++) {
      if (ch=='"') q=!q;
      if ((!q) && (ch=='\\')) {
        if ((ch=lowcase(tmp[++i]))>='1' && ch<='9' || ch>='a' && ch<='z') {
          if ((ch=(ch<='9' ? ch-'1' : ch-'a'+9))>=nprm) {err_msg(10,""); break;}
          pp=0;
          for (j=0; j<ch; j++)
           while (mpr[pp++]);
          while ((mpr[pp]) && (p<linelength))
           pline[p++]=mpr[pp++];
          if (p==linelength) err_msg(15,"");
        }
        else {
          pline[p++]=tmp[--i];
          if (p>linelength-1) err_msg(15,"");
        }
      }
      else {
        pline[p++]=tmp[i];
        if (p>linelength-1) err_msg(15,"");
      }
    }
    pline[p]=0;
  }
}

void compile(char* nam,long fpos,long lne,char tpe,char* mprm,int nprm) // "",0
{
  char mparams[256];
  char ln;
  FILE* fin;
  FILE* fil;
  FILE* fffile;
  
  int wht,w,d,c,e,i,j;
  int prm=0;
  long val;

  unsigned char cod;

  int ppoint, con;
  char ch;
                 
  long pos,lin,cnt,lcol;
  char* mpnt;

  char snum[12];
  int apoint,epoint;
  char expr[linelength];
  int st,nums;
  int fflen;
  char tnum[12];
  
  struct slabel* tmp;
  struct smacro* tmp2;

  struct stat filestat;
    
  strcpy(sname,nam);
  sline=lne-1;
  swapslash(nam);
  fin=fopen(nam,"rt");
  if (fin==NULL) err_msg(12,"");
//  if (fsetpos(fin,&fpos)) err_msg(12,"");
  if (fseek(fin,fpos,SEEK_SET)) err_msg(12,"[Compile - fseek()]");
  while (1) {
    if (feof(fin))
      if (!tpe) break;
      else {
        switch(tpe) {
          case 1: err_msg(6,".ENDM"); break;
          case 2: err_msg(6,".NEXT"); break;
          default: err_msg(6,".FI"); break;
        }
        break;
      }
    readln(fin);
    mtranslate(mprm,nprm);
#ifdef debug
    printf("%s\n",pline);
#endif
    if ((wht=what(&prm))==1) {
      if (!prm) {err_msg(5,""); continue;}
      get_ident();
      if ((wht=what(&prm))==8 || wht==12) {
        con=0;
        if(wht==12)
          if((wht=what(&prm))!=8) {err_msg(5,""); continue;}
          else con=1;
        strcpy(varname,ident);
        val=get_exp(&w,&d,&c,1);
        if (!c) continue;
        if (c==2) {err_msg(7,""); continue;}
        if (what(&prm)!=9) {err_msg(3,""); continue;}
        tmp=find_label(varname);
        if(!con)
          if (tmp) {
            if (pass==2) {tmp->forw=0; tmp->value=val;}
            else {
              if (!tmp->type)
                if (tmp->defin) {err_msg(1,varname); continue;}
              tmp->defin=1;
              if (pass==1) tmp->forw=1;
              else tmp->forw=0;
              tmp->value=val;
            }
          }
          else {
            tmp=new_label(varname);
            tmp->type=1;
            tmp->defin=1;
            if (pass==1) tmp->forw=1;
            else tmp->forw=0;
            tmp->value=val;
          }
        else
          if (tmp)
            if (pass==2) tmp->forw=0;
            else
              if (tmp->defin) err_msg(1,ident);
              else {
                tmp->type=0;
                tmp->defin=1;
                if (pass==1) tmp->forw=1;
                else tmp->forw=0;
                tmp->value=val;
              }
          else {
            tmp=new_label(ident);
            tmp->type=0;
            tmp->defin=1;
            if (pass==1) tmp->forw=1;
            else tmp->forw=0;
            tmp->value=val;
          }
        continue;
      }
      if ((wht==7) && (prm==4)) {
        if (what(&prm)!=9) {err_msg(3,""); continue;}
        tmp2=find_macro(ident);
        if ((tmp2) && (pass==1)) {err_msg(1,ident); continue;}
        if (!tmp2) {
          tmp2=new_macro(ident);
//          if (fgetpos(fin,&pos)) err_msg(12,"");
          pos=ftell(fin);
          tmp2->point=pos;
          tmp2->lin=sline;
        }
        wait_cmd(fin,5);
        continue;
      }
      if (((wht==7) && (prm>2) || (wht==10) || (wht==9))&& (listing) && (soul)) {
        fprintf(flist,".%04x                 ",address);
        if (monl) fprintf(flist,"             ");
        fprintf(flist,"%s\n",ident);
      }
      tmp=find_label(ident);
      if (tmp)
        if (pass==2) tmp->forw=0;
        else
          if (tmp->defin) err_msg(1,ident);
          else {
            tmp->type=0;
            tmp->defin=1;
            if (pass==1) tmp->forw=1;
            else tmp->forw=0;
            tmp->value=l_address;
          }
      else {
        tmp=new_label(ident);
        tmp->type=0;
        tmp->defin=1;
        if (pass==1) tmp->forw=1;
        else tmp->forw=0;
        tmp->value=l_address;
      }
    }
    switch(wht) {
      case 10: if (what(&prm)!=8) {err_msg(6,"="); break;}
               val=get_exp(&w,&d,&c,1);
               if (!c) break;
               if (c==2) {err_msg(7,""); break;}
               if (w==2) {err_msg(4,""); break;}
               if (what(&prm)!=9) {err_msg(3,""); break;}
               address=l_address=(unsigned)val;
               lastl=0;
               break;
      case 9: break;
      case 7: if (prm==0 || prm==1) {
                if ((listing) && (lastl!=2)) fprintf(flist,"\n");
                lastl=2;
                if (listing) fprintf(flist,">%04x  ",address);	// kurva anyad!
                lcol=27;
                while (1) {
                  ignore();
                  if (pline[lpoint]=='"') {
                    lpoint++;
                    while (1) {
                      if (pline[lpoint]==0) {err_msg(6,"\""); break;}
                      if ((pline[lpoint]=='"') && (pline[lpoint+1]!='"')) {lpoint++; break;}
                      if (listing) fprintf(flist,"%02x ",(unsigned)petascii(pline[lpoint]));
                      lcol-=3;
                      pokeb(&address,petascii(pline[lpoint++]));
                      if (pline[lpoint-1]=='"') lpoint++;
                    }
                    if ((ch=iget())==',') continue;
                    if (ch) {err_msg(6,","); break;}
                    break;
                  }
                  if (pline[lpoint]=='^') {
                    lpoint++;
                    val=get_exp(&w,&d,&c,1);
                    if (!c) break;
                    if (c==2) {err_msg(7,""); break;}

//                    ltoa(val,tnum,10);
		    sprintf(tnum,"%d",val);
		    
                    for(i=0; tnum[i]; i++) {
                      if (listing) fprintf(flist,"%02x ",(unsigned)tnum[i]);
                      lcol-=3;
                      pokeb(&address,tnum[i]);
                    }
                    if ((ch=iget())==',') continue;
                    if (ch) {err_msg(6,","); break;}
                    break;
                  }
                  val=get_exp(&w,&d,&c,0);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}
                  if (d==1 && (val>0xff || val<0)) {err_msg(4,""); break;}
                  if (listing) fprintf(flist,"%02x ",(unsigned)val);
                  lcol-=3;
                  pokeb(&address,val);
                  if ((ch=iget())==',') continue;
                  if (ch) {err_msg(6,","); break;}
                  break;
                }
                if (listing)
                  if (soul) {
                    for (i=0; i<lcol; i++)
                      fprintf(flist,"\n ");
                    fprintf(flist," %s",llist);
                  }
                  else fprintf(flist,"\n");
                break;
              }
              if (prm==2) {
                if (listing && lastl!=2) fprintf(flist,"\n");
                lastl=2;
                if (listing) fprintf(flist,">%04x  ",address);
                lcol=27;
                while (1) {
                  ignore();
                  val=get_exp(&w,&d,&c,0);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}
                  if (d==1 && (val>0xffff || val<0)) {err_msg(4,""); break;}
                  if (listing) fprintf(flist,"%02x %02x ",(unsigned)(val&255),(unsigned)(val>>8));
                  lcol-=6;
                  pokew(&address,(unsigned)val);
                  if ((ch=iget())==',') continue;
                  if (ch) {err_msg(6,","); break;}
                  break;
                }
                if (listing)
                  if (soul) {
                    for (i=0; i<lcol; i++)
                      fprintf(flist,"\n ");
                    fprintf(flist," %s",llist);
                  }
                  else fprintf(flist,"\n");
                break;
              }
              if (prm==3) {
                val=get_exp(&w,&d,&c,1);
                if (!c) break;
                if (c==2) {err_msg(7,""); break;}
                if (what(&prm)!=9) {err_msg(3,""); break;}
                address+=(unsigned)val & 0xffff;
                break;
              }

              if (prm==18) {
                val=get_exp(&w,&d,&c,1);
                if (!c) break;
                if (c==2) {err_msg(7,""); break;}
                if (what(&prm)!=9) {err_msg(3,""); break;}
                if (val>0xffff || val<0) {err_msg(4,""); break;}
                if (!logisave) logitab=(unsigned*)malloc(2);
                else logitab=(unsigned*)realloc(logitab,logisave*2+2);
                if(!logitab) err_msg(13,"");
                logitab[logisave++]=l_address-address;
                l_address=(unsigned)val;
                break;
              }
              if (prm==19) {
                if (what(&prm)!=9) {err_msg(3,""); break;}
                if (!logisave) {err_msg(6,".LOGICAL"); break;}
                l_address=address+logitab[--logisave];
                if(!logisave) free(logitab);
                else logitab=(unsigned*)realloc(logitab,logisave*2);
                break;
              }
              if (prm==5)
                if (tpe==1) {
                  if (what(&prm)!=9) {err_msg(3,""); break;}
                  fclose(fin);
                  return;
                }
                else {err_msg(6,".MACRO"); break;}
              if (prm==7)
                if (tpe==2) {
                  if (what(&prm)!=9) {err_msg(3,""); break;}
                  fclose(fin);
                  return;
                }
                else {err_msg(6,".FOR or .REPT"); break;}
              if (prm==11) {
                val=get_exp(&w,&d,&c,1);
                if (!c) break;
                if (c==2) {err_msg(7,""); break;}
                if (what(&prm)!=9) {err_msg(3,""); break;}
                lin=sline;
//                if (fgetpos(fin,&pos)) err_msg(12,"");
                pos=ftell(fin);
                for (cnt=0; cnt<val; cnt++) {
                  compile(nam,pos,sline,2,mprm,nprm);
                  sline=lin;
                }
                wait_cmd(fin,7);
                break;
              }
              if (prm==15) {err_msg(6,".COMMENT"); break;}
              if (prm==14) {
                wait_cmd(fin,15);
                break;
              }
              if (prm==12) {
                if (get_path()) break;
                lin=sline;
                compile(path,0,1,0,mprm,nprm);
                sline=lin;
                break;
              }
              if (prm==13) {
                if (get_path()) break;
                if (pass==1) {
                  swapslash(path);
                  fffile=fopen(path,"rb");
                  if(!fffile) {strcpy(sname,path); err_msg(12,"");}

//                  fflen=filelength(fileno(fffile));
                  stat(path,&filestat);
                  fflen=filestat.st_size; // filelength(fileno(fffile));
		  
                  address+=(unsigned)fflen;
                  l_address+=(unsigned)fflen;
                  break;
                }
                swapslash(path);
                fil=fopen(path,"rb");
                if (!fil) {strcpy(sname,path); err_msg(12,"");}
                nums=0;
                while (1) {
                  st=fread(&ch,1,1,fil);
                  if (feof(fil)) break;
                  if (!nums && listing) {
                    fprintf(flist,"\n>%04x  ",address);
                    nums=16;
                  }
                  if (listing) {fprintf(flist,"%02x ",(unsigned)ch); nums--;}
                  if (!st) {strcpy(sname,path); err_msg(12,"");}
                  pokeb(&address,ch);
                }
                if (listing) fprintf(flist,"\n");
                fclose(fil);
                break;
              }
              if (prm==6) {
                if ((wht=what(&prm))==1 && prm==1) {
                  if (get_ident()) break;
                  if (what(&prm)!=8) {err_msg(5,""); break;}
                  strcpy(varname,ident);
                  val=get_exp(&w,&d,&c,1);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}
                  tmp=find_label(varname);
                  if (tmp) {
                    if (pass==2) {tmp->forw=0; tmp->value=val;}
                    else {
                      if (!tmp->type)
                        if (tmp->defin) {err_msg(1,varname); break;}
                      tmp->defin=1;
                      if (pass==1) tmp->forw=1;
                      else tmp->forw=0;
                      tmp->value=val;
                    }
                  }
                  else {
                    tmp=new_label(varname);
                    tmp->type=1;
                    tmp->defin=1;
                    if (pass==1) tmp->forw=1;
                    else tmp->forw=0;
                    tmp->value=val;
                  }
                  if (what(&prm)!=11) {err_msg(6,","); break;}
                }
                else
                  if (wht!=11) {err_msg(6,","); break;}
                strcpy(expr,pline);
                epoint=lpoint;
                lin=sline;
                while (1) {
                  strcpy(pline,expr);
                  lpoint=epoint;
                  val=get_exp(&w,&d,&c,1);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}
                  if (!val) break;
                  if (what(&prm)!=11) {err_msg(6,","); break;}
                  apoint=lpoint;
//                  if (fgetpos(fin,&pos)) err_msg(12,"");
	          pos=ftell(fin);
                  compile(nam,pos,sline,2,mprm,nprm);
                  sline=lin;
                  strcpy(pline,expr);
                  lpoint=apoint;
                  if (what(&prm)==9) continue;
                  if (get_ident()) break;
                  if (what(&prm)!=8) {err_msg(5,""); break;}
                  strcpy(varname,ident);
                  val=get_exp(&w,&d,&c,1);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}
                  if (what(&prm)!=9) {err_msg(3,""); break;}
                  tmp=find_label(varname);
                  if (tmp) {
                    if (pass==2) {tmp->forw=0; tmp->value=val;}
                    else {
                      if (!tmp->type)
                        if (tmp->defin) {err_msg(1,varname); break;}
                      tmp->defin=1;
                      if (pass==1) tmp->forw=1;
                      else tmp->forw=0;
                      tmp->value=val;
                    }
                  }
                  else {
                    tmp=new_label(varname);
                    tmp->type=1;
                    tmp->defin=1;
                    if (pass==1) tmp->forw=1;
                    else tmp->forw=0;
                    tmp->value=val;
                  }
                }
                wait_cmd(fin,7);
                break;
              }
              if (prm==10)
                if (tpe>2) {
                  if (what(&prm)!=9) {err_msg(3,""); break;}
                  fclose(fin);
                  return;
                }
                else {err_msg(6,".IF"); break;}
              if (prm==9) {
                if (tpe==4) {err_msg(6,".FI"); break;}
                if (tpe!=3) {err_msg(6,".IF"); break;}
                if (what(&prm)!=9) {err_msg(3,""); break;}
                elseflag=1;
                fclose(fin);
                return;
                }
              if (prm==8) {
                val=get_exp(&w,&d,&c,1);
                if (!c) break;
                if (c==2) {err_msg(7,""); break;}
                if (what(&prm)!=9) {err_msg(3,""); break;}
                if (val) {
                  lin=sline;
//                  if (fgetpos(fin,&pos)) err_msg(12,"");
	          pos=ftell(fin);
                  compile(nam,pos,sline,3,mprm,nprm);
                  sline=lin;
                  if (elseflag) {
                    elseflag=0;
                    wait_cmd(fin,9);
                  }
                  wait_cmd(fin,10);
                }
                else {
                  int wrap=0;
                  while (1) {
                    if (feof(fin)) {
                      err_msg(6,".FI");
                      break;
                    }
                    readln(fin);
                    mtranslate(mprm,nprm);
                    if ((wht=what(&prm))==7 && (prm==9 || prm==10)) {
                      if (!wrap) {
                        if (prm==9) elseflag=1;
                        break;
                      }
                      else
                        if (prm==10) wrap--;
                    }
                    if (wht==7 && prm==8) wrap++;
                    if (wht==1) {
                      get_ident();
                      if ((wht=what(&prm))==7 && (prm==9 || prm==10)) {
                        if (!wrap) {
                          if (prm==9) elseflag=1;
                          break;
                        }
                        else
                          if (prm==10) wrap--;
                      if (wht==7 && prm==8) wrap++;
                      }
                    }
                  }
                  if (elseflag) {
                    elseflag=0;
                    lin=sline;
//                    if (fgetpos(fin,&pos)) err_msg(12,"");
	            pos=ftell(fin);
                    compile(nam,pos,sline,4,mprm,nprm);
                    sline=lin;
                    wait_cmd(fin,10);
                  }
                }
                break;
              }
              if (prm==17) {
                if (what(&prm)!=9) {err_msg(3,""); break;}
                if (pagelo==-1) {err_msg(6,".PAGE"); break;}
                if ((l_address>>8)!=pagelo) {err_msg(20,""); pagelo=-1; break;}
                pagelo=-1;
                break;
              }
              if (prm==16) {
                if (what(&prm)!=9) {err_msg(3,""); break;}
                if (pagelo!=-1) {err_msg(6,".ENDP"); break;}
                pagelo=(l_address>>8);
                break;
              }

      case 3:{if (get_ident()) {err_msg(5,""); break;}
              tmp2=find_macro(ident);
              if (!tmp2) {err_msg(2,ident); break;}
              ppoint=0;
              ignore();
              nprm=0;
              while ((ch=pline[lpoint])!=0) {
                if (ch=='^') {
                  nprm++;
                  lpoint++;
                  val=get_exp(&w,&d,&c,1);
                  if (!c) break;
                  if (c==2) {err_msg(7,""); break;}

//                  ltoa(val,snum,10);
                  sprintf(snum,"%d",val);

                  i=0;
                  do {
                    mparams[ppoint++]=snum[i++];
                  } while(snum[i-1]);
                  ignore();
                  if((ch=pline[lpoint])==',') lpoint++;
                  ignore();
                }
                else
                  if (ch=='"') {
                    nprm++;
                    lpoint++;
                    while (1) {
                      if (pline[lpoint]==0) {err_msg(6,"\""); break;}
                      if (pline[lpoint]=='"' && pline[lpoint+1]!='"') break;
                      mparams[ppoint++]=pline[lpoint++];
                      if (pline[lpoint-1]=='"') lpoint++;
                    }
                    if (pline[lpoint]==0) break;
                    mparams[ppoint++]=0;
                    lpoint++;
                    if ((ch=iget())==',') {ignore(); continue;}
                    if (ch) {err_msg(6,","); break;}
                  }
                  else {
                    nprm++;
                    while(ch!=',' && ch) {
                      mparams[ppoint++]=ch;
                      ch=pline[++lpoint];
                    }
                    if (ch==',') lpoint++;
                    mparams[ppoint++]=0;
                    ignore();
                  }
              }
              lin=sline;
              mpnt=tmp2->name;
              i=0;
              while (tmp2->name[i++]) mpnt++;
              mpnt++;
              compile(mpnt,tmp2->point,tmp2->lin,1,mparams,nprm);
              sline=lin;
              strcpy(sname,nam);
              break;
              }
      case 2:{int opr; int mnem;
              mnem=prm;
              if ((wht=what(&prm))==9 || wht==1 && lowcase(pline[lpoint])=='a' &&
                 pline[lpoint+1]==0 && mnem>=50 && mnem<=53) {
                 if (wht==1)
                   if (find_label("a")) err_msg(18,"");
                 opr=0;
              }
              else
                if (wht==3) {
                  opr=1;
                  val=get_exp(&w,&d,&c,pass-1);
                  if (!c) break;
                  if (what(&prm)!=9) {err_msg(3,""); break;}
                  if (c==2) {err_msg(5,""); break;}
                  if (d && (val>0xff || val<0)) {err_msg(4,""); break;}
                }
                else {
                  if (wht!=1 && wht!=10) {err_msg(5,""); break;}
                  if (wht==10) lpoint--;
                  val=get_exp(&w,&d,&c,pass-1);
                  if (!c) break;
                  if (c==1) {
                    opr=2;
                    if ((wht=what(&prm))==4) {
                      opr=4;
                      if (what(&prm)!=9) {err_msg(3,""); break;}
                    }
                    else
                      if (wht==5) {
                        opr=6;
                        if (what(&prm)!=9) {err_msg(3,""); break;}
                      }
                      else
                        if (wht!=9) {err_msg(3,""); break;}
                    if (d && (val>0xffffl || val<0)) {err_msg(4,""); break;}
                    if (w==0) opr++;
                  }
                  else
                    if (c==2) {
                      if (what(&prm)!=6) {err_msg(5,""); break;}
                      if (what(&prm)!=9) {err_msg(5,""); break;}
                      opr=12;
                      if (d && (val>0xffff || val<0)) {err_msg(3,""); break;}
                      if (w==0) opr=8;
                    }
                    else {
                      if ((wht=what(&prm))==5) {
                        if (what(&prm)!=9) {err_msg(5,""); break;}
                        opr=9;
                        if (d && (val>0xff || val<0)) {err_msg(3,""); break;}
                      }
                      else {
                        if (wht!=9) {err_msg(3,""); break;}
                        opr=10;
                        if (d && (val>0xffffl || val<0)) {err_msg(4,""); break;}
                        if (w==0) opr++;
                      }
                    }
                }

              cod=c6502[mnem][opr];

              e=0;
              while (cod==0xff) {
                e=1;
                if (opr<2 || opr==9) {err_msg(17,""); break;}
                if (opr==2 || opr==4 || opr==6) {
                  if ((cod=c6502[mnem][++opr])==0xff) {err_msg(17,""); break;}
                  if (d && val>0xff) {err_msg(4,""); break;}
                  e=0;
                  break;
                }
                if (opr==3 || opr==5 || opr==7) {
                  if ((cod=c6502[mnem][--opr])==0xff) {err_msg(17,""); break;}
                  e=0;
                  break;
                }
                if (opr==12) {
                  if ((cod=c6502[mnem][opr=8])==0xff) {err_msg(17,""); break;}
                  if (d && val>0xff) {err_msg(4,""); break;}
                  e=0;
                  break;
                }
                if (opr==8) {
                  if ((cod=c6502[mnem][opr=12])==0xff) {err_msg(17,""); break;}
                  e=0;
                  break;
                }
                if (opr==10) {
                  if ((cod=c6502[mnem][++opr])<0xff) {
                    if (d && val>0xff) {err_msg(4,""); break;}
                    e=0;
                    break;
                  }
                  cod=c6502[mnem][opr=2];
                  e=0;
                  continue;
                }
                if (opr==11) {
                  if ((cod=c6502[mnem][--opr])<0xff) {e=0; break;}
                  cod=c6502[mnem][opr=3];
                  e=0;
                  continue;
                }
              }
              if (e) break;
              if (listing && lastl!=1) fprintf(flist,"\n");
              lastl=1;
              if (listing) fprintf(flist,".%04x  %02x ",address,(unsigned)cod);
              pokeb(&address,cod);
              if ((ln=leno[opr])>1) {
                if (ln==2) {
                    if (listing) fprintf(flist,"%02x      ",(unsigned)(val&255));
                    pokeb(&address,(unsigned char)val);
                  }
                else {
                  if (mnem>=23 && mnem<=30 || mnem==61) {
                    int br=(unsigned)val-l_address-1;
                    if ((br<-128 || br>127) && d) {err_msg(9,""); break;}
                    pokeb(&address,(unsigned char)br);
                    if (listing) fprintf(flist,"%02x      ",br&255);
                  }
                  else {
                  pokeb(&address,(unsigned char)val&255);
                  pokeb(&address,(unsigned char)(val>>8));
                  if (listing) fprintf(flist,"%02x %02x   ",(unsigned)(val&255),(unsigned)(val>>8));
                  }
                }
              }
              else
                if (listing) fprintf(flist,"        ");
              if (listing) {
                if (monl) {
                  fprintf(flist,"%s ",mnemonic[mnem]);
                  switch (opr) {
                    case 0: fprintf(flist,"         "); break;
                    case 1: fprintf(flist,"#$%02x     ",(unsigned)(val&255)); break;
                    case 2: if (mnem>=23 && mnem<=30 || mnem==61)
                              fprintf(flist,"$%04x    ",(unsigned)(val+address-l_address));
                            else fprintf(flist,"$%04x    ",(unsigned)val);
                            break;
                    case 3: fprintf(flist,"$%02x      ",(unsigned)(val&255)); break;
                    case 4: fprintf(flist,"$%04x,x  ",(unsigned)val); break;
                    case 5: fprintf(flist,"$%02x,x    ",(unsigned)(val&255)); break;
                    case 6: fprintf(flist,"$%04x,y  ",(unsigned)val); break;
                    case 7: fprintf(flist,"$%02x,y    ",(unsigned)(val&255)); break;
                    case 8: fprintf(flist,"($%02x,x)  ",(unsigned)(val&255)); break;
                    case 9: fprintf(flist,"($%02x),y  ",(unsigned)(val&255)); break;
                    case 10: fprintf(flist,"($%04x)  ",(unsigned)val); break;
                    case 11: fprintf(flist,"($%02x)    ",(unsigned)(val&255)); break;
                    case 12: fprintf(flist,"($%04x,x)",(unsigned)val); break;
                  }
                }
                if (soul) fprintf(flist,"    %s",llist);
                else fprintf(flist,"\n");
              }
              break;
              }
      default: err_msg(5,"");
    }
  }
  fclose(fin);
}

int main(int argc,char *argv[]) {
 int srcpm,i,j;
 char ch;

 int lb;
 struct slabel* tmp;
 char source_n[80],object_n[80],listing_n[80];
 time_t t;

 long val;

 FILE* fout;
 FILE* flab;
 
  printf("6502/65C02 Turbo Assembler  Version 1.3  Copyright (c) 1997 Taboo Productions\n");
  printf("6502/65C02 Turbo Assembler  Version 1.35 ANSI C port by [BiGFooT/BReeZe^2000]\n");
  for(srcpm=1; srcpm<argc; srcpm++) if (*argv[srcpm]=='/') {
   switch(*(argv[srcpm]+1)) {
    case 'n': nlin=1; break;
    case 'w': w_on=0; break;
    case 'a': ascc=1; break;
    case 'c': { last_mnem=63;
              for (i=0; i<CNUM; i++)
                c6502[cmnem[i]][copr[i]]=ccode[i];}
              break;
    case 'm': monl=0; break;
    case 's': soul=0; break;
    case 'l': {labfile=1;
               j=0; i=2;
               while ((ch=*(argv[srcpm]+i++))!=0) labname[j++]=ch;
               labname[j]=0;
               if (!j) help();
               break;}
    default: help();
    }
   }
  else break;
  
  if (argc==srcpm) help();
  strcpy(source_n,argv[srcpm]);
  if (!strchr(source_n,'.')) strcat(source_n,".TAS");
  printf("\nAssembling file:   %s",source_n);
  srcpm++;
  if (argc==srcpm) {
   printf("\n");
   strcpy(object_n,source_n);
   i=0;
   while (object_n[i]!='.') i++;
   object_n[i]=0;
   if (nlin) strcat(object_n,".n64");
   else strcat(object_n,".o64");
   }
  else {
   strcpy(object_n,argv[srcpm]);
   if (!strchr(object_n,'.')) if (nlin) strcat(object_n,".N64");
                              else strcat(object_n,".O64");
   printf("  to  %s\n",object_n);
   }
  if (!(mem64=(unsigned char*)malloc(65536u))) err_msg(13,"");
  if (nlin) if (!(mmap=(unsigned char*)malloc(8192))) err_msg(13,"");
  memset(mem64,0,65536u);
  if (nlin) memset(mmap,0,8192);
  
  compile(source_n,0,1,0,"",0);
  
  srcpm++;
  if (argc>srcpm) {
   strcpy(listing_n,argv[srcpm]);
   if (!strchr(listing_n,'.')) strcat(listing_n,".L64");
   listing=1;
   }
   
  if (!errors) {
   pass++;
   address=l_address=0;
   if (listing) {
    swapslash(listing_n);
    if (!(flist=fopen(listing_n,"wt"))) err_msg(19,listing_n);
    fprintf(flist,"\n6502/65C02 Turbo Assembler listing file of \"%s\"\n",source_n);
    time(&t);
    fprintf(flist,"done on %s\n",ctime(&t));
    }
    
   compile(source_n,0,1,0,"",0);
   if (listing) {
    fprintf(flist,"\n--- end of code ---\n");
    fclose(flist);
    }
    
   if (labfile) {
    swapslash(labname);
    if (!(flab=fopen(labname,"wt"))) err_msg(21,labname);
    for(lb=0; lb<27; lb++) {
     tmp=labels[lb];
     while (tmp) {
      fprintf(flab,"%c%-16s= ",lb==26 ? '_' : lb+'a',tmp->name);
      if ((val=tmp->value)<0) fprintf(flab,"-");
      if (val>-0x100 && val<0x100) fprintf(flab,"$%02lx\n",val>=0?val:-val);
      else if (val>-0x10000l && val<0x10000l) fprintf(flab,"$%04lx\n",val>=0?val:-val);
           else fprintf(flab,"$lx\n",val>=0?val:-val);
      tmp=tmp->another;
      }
     }
     fclose(flab);
    }
    
   }
   
  if (!errors) {
   if (low_mem<=top_mem) {
    swapslash(object_n);
    fout=fopen(object_n,"wb");
    if (fout==NULL) err_msg(14,object_n);
    if (nlin) {
     unsigned bl_adr=low_mem, bl_len;
     while(bl_adr<=top_mem) {
      while(!(mmap[(bl_adr)>>3] & (1<<((bl_adr) & 7)))) bl_adr++;
      bl_len=0;
      while((long)bl_adr+bl_len<65536l && bl_len<65535u && (mmap[(bl_adr+bl_len)>>3] & (1<<((bl_adr+bl_len) & 7)))) bl_len++;
      fwrite(&bl_len,2,1,fout);
      fwrite(&bl_adr,2,1,fout);
      if ((bl_adr^(bl_adr+bl_len-1))>32767u) {
       if (fwrite(mem64+bl_adr,32768u-bl_adr,1,fout)==0) err_msg(14,object_n);
       if (fwrite(mem64+32768u,bl_adr+bl_len-32768u,1,fout)==0) err_msg(14,object_n);
       }
      else {
       if (bl_adr<32768u) {
        if (fwrite(mem64+bl_adr,bl_len,1,fout)==0) err_msg(14,object_n);
        }
       else if (fwrite(mem64+32768+(bl_adr-32768u),bl_len,1,fout)==0) err_msg(14,object_n);
       }
      bl_adr+=bl_len;
      if(!bl_adr) break;
      }
     bl_len=0;

     fwrite(&bl_len,2,1,fout);
     }
    else {
     fwrite(&low_mem,2,1,fout);
     if ((low_mem^top_mem)>32767u) {
      if (fwrite(mem64+low_mem,32768u-low_mem,1,fout)==0) err_msg(14,object_n);
      if (fwrite(mem64+32768,top_mem-32767u,1,fout)==0) err_msg(14,object_n);
      }
     else {
      if (low_mem<32768u) {
       if (fwrite(mem64+low_mem,top_mem-low_mem+1,1,fout)==0) err_msg(14,object_n);
       }
      else if (fwrite(mem64+32768+(low_mem-32768u),top_mem-low_mem+1,1,fout)==0) err_msg(14,object_n);
      }
     }
    if (fclose(fout)) err_msg(14,object_n);
    status();
    return 0;
    }
   }
  
  else {
   status();
   return 1;
   }
  return 0;
  }
