// ----------------------------------------------------------------------------
#ifndef BSTRING_H
#define BSTRING_H
// ----------------------------------------------------------------------------
char upcase(char ch) { if ((ch>=97) && (ch<=122)) ch-=32; return ch; }
char lowcase(char ch) { if ((ch>=65) && (ch<=90)) ch+=32; return ch; }
// ----------------------------------------------------------------------------
int searchinstring(char *defaultstring, char *searchstring) {
 int qi;
 int result=0;
 char *tempstring;

 tempstring = (char *)malloc(strlen(defaultstring)+1);

 if ( tempstring != NULL ) {
  memcpy (tempstring, defaultstring, strlen(defaultstring)+1);

  if ((strlen(tempstring)>0) & (strlen(searchstring)>0)) {
   while ((strlen(tempstring)>=strlen(searchstring)) & (result == 0)) {
    result = 1;
    for ( qi=0; qi<strlen(searchstring); qi++ ) {
     if (upcase(tempstring[qi]) != upcase(searchstring[qi])) { result = 0; }
     }
    if (result == 0) { memmove (tempstring, tempstring+1, strlen(tempstring)); }
    }
   }

  free(tempstring);
  }

 return result;
 }

// ----------------------------------------------------------------------------

int searchinstringpos(char *defaultstring, char *searchstring) {
 int i;
 int result=0;
 int pos=0;

 char *tempstring;

 tempstring = (char *)malloc(strlen(defaultstring)+1);

 if ( tempstring != NULL ) {
  memcpy (tempstring, defaultstring, strlen(defaultstring)+1);

  if ((strlen(tempstring)>0) & (strlen(searchstring)>0)) {
   while ((strlen(tempstring)>=strlen(searchstring)) & (!result)) {
    result = 1;
    for ( i=0; i<strlen(searchstring); i++ ) {
     if (upcase(tempstring[i]) != upcase(searchstring[i])) { result = 0; }
     }
    if (!result) { pos++; memmove (tempstring, tempstring+1, strlen(tempstring)); }
    }
   }

  free(tempstring);
  }

 if (!result) { return 0; }
 else { return pos; }
 }

// ----------------------------------------------------------------------------

int searchinstringpos2(char *defaultstring, char *searchstring) {
 int i;
 int result=0;
 int pos=0;

 char *tempstring;

 tempstring = (char *)malloc(strlen(defaultstring)+1);

 if ( tempstring != NULL ) {
  memcpy (tempstring, defaultstring, strlen(defaultstring)+1);

  if ((strlen(tempstring)>0) & (strlen(searchstring)>0)) {
   while ((strlen(tempstring)>=strlen(searchstring)) & (!result)) {
    result = 1;
    for ( i=0; i<strlen(searchstring); i++ ) {
     if (upcase(tempstring[i]) != upcase(searchstring[i])) { result = 0; }
     }
    if (!result) { pos++; memmove (tempstring, tempstring+1, strlen(tempstring)); }
    }
   }

  free(tempstring);
  }

 if (!result) { return -1; }
 else { return pos; }
 }

// ----------------------------------------------------------------------------

int comparestringbegin(const char *str1, const char *str2)
{
 int okay=1;
 int i;

 for (i=0; i<strlen(str2); i++) {
  if (upcase(str1[i]) != upcase(str2[i])) {
   okay = 0;
   }
  }
 return okay;
 }

// ----------------------------------------------------------------------------

void dropcontrolchars(char *sourcestring) {
 int qi;
 for (qi=0; qi<strlen(sourcestring); qi++ ) { if ((sourcestring[qi]<32) && (sourcestring[qi]>=0)) { sourcestring[qi]=32; }}
 }

// ----------------------------------------------------------------------------

void cutfirstspaces(char *sourcestring) {
 int qi=0,length;
 length=strlen(sourcestring);
 
 while ((qi<=length) && (sourcestring[qi]==32)) qi++;
 if (qi>0) memmove(sourcestring,sourcestring+qi,length-qi+1);
 }

// ----------------------------------------------------------------------------

void cutlastspaces(char *sourcestring) {
 int qi;
 
 qi=strlen(sourcestring);
 while ((qi>0) && (sourcestring[qi-1]==32)) qi--;
 if ((qi==0) && (sourcestring[0]==32)) qi=-1;
 sourcestring[qi+1]=0x00;
 }

// ----------------------------------------------------------------------------

void upcasestring(char *sourcestring) {
 int qi;
 for (qi=0; qi<strlen(sourcestring); qi++ ) { sourcestring[qi]=upcase(sourcestring[qi]); }
 }

// ----------------------------------------------------------------------------

void cutfirstword(char *sourcestring, char *deststring) {
 int templen;
 char okay=0;

 deststring[0]=0;

 while ((strlen(sourcestring)>0) & (okay==0)) {
  templen=strlen(deststring);
  if ((sourcestring[0]<=32) && (sourcestring[0]>=0)) okay=1;
  else deststring[templen]=sourcestring[0]; deststring[templen+1]=0;
  memcpy(sourcestring,sourcestring+1,strlen(sourcestring));
  }

 }

// ----------------------------------------------------------------------------

void cutlastword(char *sourcestring, char *deststring) {
 int templen;
 char okay=0;

 deststring[0]=0;

 templen=strlen(sourcestring)+1;
 while ((templen>0) & (okay==0)) {
  templen--;
  if ((sourcestring[templen]<=32) && (sourcestring[templen]>=0)) okay=1;
  }
 memcpy(deststring,sourcestring+templen+okay,strlen(sourcestring)-templen+1);
 sourcestring[templen]=0x00;
 }

// ----------------------------------------------------------------------------

int comparestring(char *defaultstring, char *searchstring) {
 int i;
 int result=0;

 if (strlen(defaultstring)==strlen(searchstring)) {
  result = 1;
  for ( i=0; i<strlen(searchstring); i++ ) {
   if (upcase(defaultstring[i]) != upcase(searchstring[i])) { result = 0; }
   }
  }

 return result;
 }

// ----------------------------------------------------------------------------

void cutfirstline(char *sourcestring, char *deststring) {
 char okay=0;

 int copypos=0;
 int length=0;
 deststring[0]=0;
 
 length=strlen(sourcestring);

 if (length>0) {
  while ((copypos<length) && (!okay)) {
   if (sourcestring[copypos]=='\n') okay=1;
   else { copypos++; }
   }
  if (okay) {
   memcpy(deststring,sourcestring,copypos+1); deststring[copypos+1]=0;
   memmove(sourcestring,sourcestring+copypos+1,strlen(sourcestring)-copypos);
   }
  }

 }

// ----------------------------------------------------------------------------

void cutfirstword2(char *sourcestring, char *deststring, char seperator) {
 int templen;
 char okay=0;

 deststring[0]=0;

 while ((strlen(sourcestring)>0) & (okay==0)) {
  templen=strlen(deststring);
  if (sourcestring[0]==seperator) okay=1;
  else { deststring[templen]=sourcestring[0]; deststring[templen+1]=0; }
  memcpy(sourcestring,sourcestring+1,strlen(sourcestring));
  }

 }

// ----------------------------------------------------------------------------

void cutfirstword3(char *sourcestring, char *deststring, char *seperator) {
 int templen;
 char okay=0;
 char tempquery[3]="\0\0";
 
 deststring[0]=0;

 while ((strlen(sourcestring)>0) & (okay==0)) {
  templen=strlen(deststring);
  tempquery[0]=sourcestring[0];
  if (searchinstring(seperator,tempquery)) okay=1;
  else {
   deststring[templen]=sourcestring[0]; deststring[templen+1]=0;
   memcpy(sourcestring,sourcestring+1,strlen(sourcestring));
   }
  }

 }

// ----------------------------------------------------------------------------

void cutlastword2(char *sourcestring, char *deststring, char seperator) {
 int templen;
 char okay=0;

 deststring[0]=0;

 templen=strlen(sourcestring)+1;
 while ((templen>0) & (okay==0)) {
  templen--;
  if (sourcestring[templen]==seperator) okay=1;
  }
 memcpy(deststring,sourcestring+templen+okay,strlen(sourcestring)-templen+1);
 sourcestring[templen]=0x00;
 }

// ----------------------------------------------------------------------------
void swapchars(char *sourcestring,char sourcechar,char destchar) {
 int qi;

 for (qi=0; qi<strlen(sourcestring); qi++) { if (sourcestring[qi]==sourcechar) sourcestring[qi]=destchar; }
 }
// ----------------------------------------------------------------------------
void swapslash(char *sourcestring) {
 swapchars(sourcestring,'\\','/');
 }
// ----------------------------------------------------------------------------
#endif
// ----------------------------------------------------------------------------
